import { createRouter, createWebHistory, RouteRecordRaw } from "vue-router";
import HomeView from "../views/HomeView.vue";
import RegisterView from "../views/RegisterView.vue";

const routes: Array<RouteRecordRaw> = [
  {
    path: "/",
    name: "home",
    component: HomeView,
  },
  {
    path: "/register",
    name: "register",
    component: RegisterView,
  },
  {
    path: "/offer-page",
    name: "OfferPage",
    meta: {
      requiresAuth: true
    },
    component: () =>
      import(/* webpackChunkName:  "about" */ "../views/OfferView.vue"),
  },
  {
    path: "/wishlist-page",
    name: "WishlistPage",
    meta: {
      requiresAuth: true
    },
    component: () =>
      import(/* webpackChunkName: "about" */ "../views/WishlistView.vue"),
  },
  {
    path: "/login-main-page",
    name: "LoginMainPage",
    meta: {
      requiresAuth: true
    },
    component: () =>
      import("../views/LoginMainPageView.vue"),
  }
];

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes,
});

router.beforeEach((to, from, next) => {
  if (to.matched.some(record => record.meta.requiresAuth)) {
    if (!document.cookie) {
      next({ name: 'home' })
    } else {
      next()
    }
  } else {
    next()
  }
})

export default router;
